unit SplineOpt;
{$I DFS.inc}{Copyright (C) 2005 C M Western; see AdvOpt.pas for license}
interface

uses
  SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, NewSpin, AlEdit, EditExtr;

type
  TSplineDlg = class(TForm)
    EveryPointRadioItem: TRadioButton;
    GroupBox: TGroupBox;
    AvgErrorRadioButton: TRadioButton;
    EquallySpacedRadioButton: TRadioButton;
    nPointsSpin: TSpinBox;
    AvgErrorSpin: TFixedSpin;
    OKButton: TButton;
    CancelButton: TButton;
    UpdateNowCheckBox: TCheckBox;
    procedure AvgErrorSpinIncrement(Sender: TObject; var NewValue: Double;
      LastValue: Double; n: Integer);
    procedure EveryPointRadioItemClick(Sender: TObject);
    procedure OKButtonClick(Sender: TObject);
    procedure CancelButtonClick(Sender: TObject);
    procedure nPointsSpinChange(Sender: TObject);
    procedure AvgErrorSpinChange(Sender: TObject);
  public
    procedure UpdateExpr;
  end;

implementation

uses Gendlg;

{$IFNDEF FPC}
{$R *.dfm}
{$ELSE}
{$R *.lfm}
{$ENDIF}

procedure TSplineDlg.AvgErrorSpinChange(Sender: TObject);
begin
  AvgErrorRadioButton.Checked := True;
  EveryPointRadioItemClick(Sender);
end;

procedure TSplineDlg.AvgErrorSpinIncrement(Sender: TObject; var NewValue: Double; LastValue: Double; n: Integer);
begin
  NewValue := SpinScaleBy(n,10,LastValue);
end;

procedure TSplineDlg.CancelButtonClick(Sender: TObject);
begin
  Close;
end;

procedure TSplineDlg.EveryPointRadioItemClick(Sender: TObject);
begin
  if not (csLoading in ComponentState) and UpdateNowCheckBox.Checked then
    UpdateExpr;
end;

procedure TSplineDlg.nPointsSpinChange(Sender: TObject);
begin
  EquallySpacedRadioButton.Checked := True;
  EveryPointRadioItemClick(Sender);
end;

procedure TSplineDlg.OKButtonClick(Sender: TObject);
begin
  UpdateExpr;
  Close;
end;

procedure TSplineDlg.UpdateExpr;
begin
  with Owner as TNLFitDlg do begin
    if EveryPointRadioItem.Checked then
      FunctionText := 'spline(x,observed,weight)'
    else if AvgErrorRadioButton.Checked then
      FunctionText := 'spline(x,observed,weight,'+AvgErrorSpin.Text+')'
    else if EquallySpacedRadioButton.Checked then
      FunctionText := 'spline(x,observed,weight,-'+nPointsSpin.Text+')';
    FitOnceClick(nil);
  end;
end;

end.
