unit DataSource;
{$I DFS.inc}{ Copyright (C) 2005 C M Western; see NLFit.pas for license}
interface

uses SysUtils, Classes, Expr;

type

  TDataSource = class (TComponent)
  public
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
    procedure AddIndependentVariables(Lex:TLex); virtual; abstract;
    function nRows: Integer; virtual; abstract;
    function GetData(r: Longint; var x, y, w: Double; SetVariableControlsState: Boolean = False; ExtraAxis: Integer = -1): Boolean; virtual; abstract;
    function Weighted: Boolean; virtual; abstract;
    function Caption: string; virtual; abstract;
    procedure SetFitExpr(Expr: TExpr; nPar: Integer); virtual; abstract;
  end;

var
  DataSources: array of TDataSource;

type
  EFitError = class(Exception);

implementation

{ TDataSource }

constructor TDataSource.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  SetLength(DataSources, Length(DataSources)+1);
  DataSources[High(DataSources)] := Self;
end;

destructor TDataSource.Destroy;
var
  i, j: Integer;
begin
  for i := 0 to High(DataSources) do
    if DataSources[i] = Self then begin
      for j := i+1 to High(DataSources) do
        DataSources[j-1] := DataSources[j];
      SetLength(DataSources, Length(DataSources)-1);
      Break;
    end;
  inherited;
end;


end.
