unit DataTypes;
{$I DFS.inc}{Copyright (C) 2008 C M Western; see NLFit.pas for license}
interface

type

  TDataType = (tyNone, tyInt16, tyInteger, tySingle, tyDouble, tyInt64, tyShorts, tySmalls, tyIntegers);
  TSeriesDataType = tyShorts..tyIntegers;

const
  DataTypeSize: array [TDataType] of Integer =
    (0, 2, 4, 4, 8, 8, 1, 2, 4); { Size in bytes of one value; for seriew data type the size of one element of the series }

function DataTypeName(DataType: TDataType):string;
function TryStrToDataType(Str: string; out DataType: TDataType):Boolean;
function IsSeries(DataType: TDataType):Boolean;

implementation

uses Sysutils;

const
  TypeNames: array [TDataType] of string = (
    'None', '16 bit integer', 'Integer', 'Single', 'Double', '64 bit integer', '8 bit series', '16 bit series', '32 bit series');

function DataTypeName(DataType: TDataType):string;
begin
  Result := TypeNames[DataType];
end;

function IsSeries(DataType: TDataType):Boolean;
begin
  Result := DataType in [Low(TSeriesDataType)..High(TSeriesDataType)];
end;

function TryStrToDataType(Str: string; out DataType: TDataType):Boolean;
var
  i: TDataType;
begin
  Result := True;
  if Str = 'Cardinal' then begin
    DataType := tyInteger; { Backward compatibility with early versions }
    Exit;
  end;
  for i := Low(TDataType) to High(TDataType) do
    if CompareText(Str,TypeNames[i]) = 0 then begin
      DataType := i;
      Exit;
    end;
  DataType := tyNone;
  Result := False;
end;

end.
