unit ConstFrm;
{$I DFS.inc}{Copyright (C) 2005 C M Western; see commandline.pas for license}
interface

uses
  {$IFDEF MSWINDOWS} Windows, Messages, {$ENDIF} ChildForm, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Grids, NGrid, Mixture, ExtCtrls, StdCtrls, ComCtrls,
  Split, Menus, Buttons, GridEx, MNode, Settings;

type

  { TConstantsForm }

  TConstantsForm = class(TChildForm)
    AllMatrixElementsItem: TMenuItem;
    CopyWithLabelsItem: TMenuItem;
    RemoveItem: TMenuItem;
    RemoveAllLevelsItem: TMenuItem;
    Panel: TPanel;
    ParGrid: TNumberGrid;
    ActiveObject: TComboBox;
    OptGrid: TStringGridEx;
    TreeView: TTreeView;
    SplitL: TSplit;
    SplitR: TSplit;
    TreePopupMenu: TPopupMenu;
    RenameItem: TMenuItem;
    FixAllButton: TSpeedButton;
    ConvertUnitsButton: TSpeedButton;
    CopyItem: TMenuItem;
    DeleteItem: TMenuItem;
    PasteItem: TMenuItem;
    StatusBar: TStatusBar;
    UnitsLabel: TLabel;
    ValuePanel: TPanel;
    CommentPanel: TPanel;
    Label1: TLabel;
    CommentEdit: TEdit;
    MoveUpItem: TMenuItem;
    MoveDownItem: TMenuItem;
    CopyWithLinkedItemsItem: TMenuItem;
    SelectPanel: TPanel;
    AddNewItem: TMenuItem;
    ConvertItem: TMenuItem;
    ParPopupMenu: TPopupMenu;
    CopyParItem: TMenuItem;
    PasteParItem: TMenuItem;
    EditParItem: TMenuItem;
    CutParItem: TMenuItem;
    ClearParItem: TMenuItem;
    MatrixElementsItem: TMenuItem;
    ConverttoPerturbationItem: TMenuItem;
    AddAllLevelsItem: TMenuItem;
    SymmetryTableItem: TMenuItem;
    OptPopupMenu: TPopupMenu;
    OptEditItem: TMenuItem;
    OptCutItem: TMenuItem;
    OptCopyItem: TMenuItem;
    OptCopyWithLabelsItem: TMenuItem;
    OptPasteItem: TMenuItem;
    OptClearItem: TMenuItem;
    AddAllLevelsTreeItem: TMenuItem;
    ShowFullNameItem: TMenuItem;
    AddParameterItem: TMenuItem;
    TurnonMouseAdjustItem: TMenuItem;
    AbortMouseAdjustItem: TMenuItem;
    procedure CopyWithLabelsItemClick(Sender: TObject);
    procedure ParGridChangeCellQuery(Sender: TObject; Col, Row: Integer;
      var CanChange: Boolean);
    procedure AddAllLevelsItemClick(Sender: TObject);
    procedure ConverttoPerturbationItemClick(Sender: TObject);
    procedure AllMatrixElementsItemClick(Sender: TObject);
    procedure MatrixElementsItemClick(Sender: TObject);
    procedure RemoveAllLevelsItemClick(Sender: TObject);
    procedure RemoveItemClick(Sender: TObject);
    procedure TreeViewCustomDrawItem(Sender: TCustomTreeView; Node: TTreeNode;
      State: TCustomDrawState; var DefaultDraw: Boolean);
    procedure ClearParItemClick(Sender: TObject);
    procedure ParPopupMenuPopup(Sender: TObject);
    procedure EditParItemClick(Sender: TObject);
    procedure PasteParItemClick(Sender: TObject);
    procedure CutParItemClick(Sender: TObject);
    procedure CopyParItemClick(Sender: TObject);
    procedure ConvertItemClick(Sender: TObject);
    procedure AddNewItemClick(Sender: TObject);
    procedure OptGridDblClick(Sender: TObject);
    procedure OptGridMouseDown(Sender: TOBject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure OptGridSelectCell(Sender: TObject; ACol, ARow: Integer;
      var CanSelect: Boolean);
    procedure ParGridExit(Sender: TObject);
    procedure ParGridSelectCell(Sender: TObject; ACol, ARow: Integer;
      var CanSelect: Boolean);
    procedure ParGridGetCellIsFlag(Sender: TObject; Col, Row: Integer;
      var IsFlag: Boolean);
    procedure ParGridDblClick(Sender: TObject);
    procedure ParGridMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure ParGridChanged(Sender: TObject; Col, Row: Integer);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure TreeViewChange(Sender: TObject; Node: TTreeNode);
    procedure TreeViewEdited(Sender: TObject; Node: TTreeNode;
      var S: String);
    procedure RenameItemClick(Sender: TObject);
    procedure OptGridSetEditText(Sender: TObject; ACol, ARow: Integer;
      const Value: String);
    procedure FixAllButtonClick(Sender: TObject);
    procedure ConvertUnitsButtonClick(Sender: TObject);
    procedure OptGridGetEditStyle(Sender: TObject; ACol, ARow: Integer;
      var Style: TEditStyle);
    procedure OptGridGetPickListItems(ACol, ARow: Integer;
      Items: TStrings);
    procedure CopyItemClick(Sender: TObject);
    procedure TreePopupMenuPopup(Sender: TObject);
    procedure PasteItemClick(Sender: TObject);
    procedure DeleteItemClick(Sender: TObject);
    procedure TreeViewKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure TreeViewMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure FormDeactivate(Sender: TObject);
    procedure CommentEditChange(Sender: TObject);
    procedure MoveUpItemClick(Sender: TObject);
    procedure MoveDownItemClick(Sender: TObject);
    procedure CopyWithLinkedItemsItemClick(Sender: TObject);
    procedure SymmetryTableItemClick(Sender: TObject);
    procedure OptPopupMenuPopup(Sender: TObject);
    procedure OptCutItemClick(Sender: TObject);
    procedure OptCopyItemClick(Sender: TObject);
    procedure OptCopyWithLabelsItemClick(Sender: TObject);
    procedure OptPasteItemClick(Sender: TObject);
    procedure OptEditItemClick(Sender: TObject);
    procedure OptClearItemClick(Sender: TObject);
    procedure FormHide(Sender: TObject);
    procedure ShowFullNameItemClick(Sender: TObject);
    procedure ParGridMouseWheel(Sender: TObject; Shift: TShiftState;
      WheelDelta: Integer; MousePos: TPoint; var Handled: Boolean);
    procedure AddParameterItemClick(Sender: TObject);
    procedure ParGridDrawCellContents(Sender: TObject; ACol, ARow: Integer;
      Rect: TRect; State: TGridDrawState; var Drawn: Boolean);
    procedure TurnonMouseAdjustItemClick(Sender: TObject);
    procedure AbortMouseAdjustItemClick(Sender: TObject);
  private
    LastCell: TPoint;
    LastError: string;
    LastRow: Integer; { of error }
    nInitialTreeMenuItems: Integer;
    WheelAdjustActive: Boolean;
    WheelCount: Integer;
    LastBoldRow: Integer; { To ensure correct re-painting of mouse adjustable cell }
    LastAdjustedRow: Integer;
    LastAdjustedValue: Double;
    {$IFDEF LCL_}
    TurnOnEditing: Boolean;
    procedure TreeViewSelectionChanged(Sender: TObject);
    {$ENDIF}
    {$IFDEF VCL_}
    procedure WMHelp(var Message: TWMHelp); message WM_HELP;
    {$ENDIF}
    procedure CopyItemsToClipboard(LinkedItems: Boolean);
  protected
    SelectorComboBoxTop, SelectorComboBoxLeft, MarginSize: Integer; { Helpers for window flip logic }
    procedure MNodeChange(Sender: TMnode; Change: TMNodeChange; Index: Integer); override;
    procedure ParameterChanged(MNode: TMNode; Index: Integer); override;
    procedure SettingChanged(MNode: TMNode; Index: Integer); override;
    procedure PropNameChanged(MNode: TMNode; Index: Integer); override;
    function StuffObject(const Name1, Name2: string; MNode: TMNode; var ParentNode: TTreeNode): Integer; override;
    procedure CheckForNameChange;
    procedure UpdateActions; override;
    procedure HandleControl(Control: TControl; var PName, Value, PHint: string; var Save: Boolean; var SettingType: TSettingType; Write: Boolean); override;
    procedure EmptyParGrid;
    { Helper functions to hide TreeView multiselect differences }
    function nSelectedNodes:Integer;
    function SelectedNode(Index:Integer):TMNode;
    function MoveUpDown(Shift: Integer; Test: Boolean):Boolean;
  public
    constructor Create(AOwner: TComponent); override;
    procedure AdjustSplitters;
    function BaseNodeClass: TClass; override;
    procedure ShowItem(MNode: TMNode); override;
    procedure UpdateCorrelation(Correlations: TCorrelations);
    procedure StuffSelector(MNode: TMNode); override;
    function DefaultCaption: string; virtual;
    procedure UpdateAlwaysVisible; virtual;
    function PasteItemsIntoTree: Boolean;
    procedure FlipOrientation;
    procedure ArrangeForm(Screen: TRect); override;
    function MNodeFromTreeNode(TreeNode: TTreeNode): TMNode;
  end;

var
  ConstantsForm: TConstantsForm;

implementation

uses {$IFDEF LCL_} LResources, LCLType, AlignHelp, LCLIntf, {$ENDIF}
     Global, Constrain, MNodeColour, WCompat, MNodeClip, Overlay, OvrlyFrm,
     ClipBrd, RenForm, Units, WhatsThis, PropHelp, LogUnit, Math,
     Expr, MatrixElements, Profile, QuantumNumber, CalSource, Main, Worker,
     SettingsForm, Types, MDIFix, Vib, pgDOM, pgXMLWrite, Contnrs, Huge;

{$IFNDEF FPC}
{$R *.dfm}
{$ELSE}
{$R *.lfm}
{$ENDIF}

{ TConstantsForm }

procedure TConstantsForm.StuffSelector(MNode: TMNode);
var
  NewCaption: string;
begin
  OptGrid.EditorMode := False;
  ParGrid.EditorMode := False;
  StatusBar.Panels[StatusBar.Panels.Count-1].Text := '';
  try
    inherited;
  except
    on E: Exception do
      StatusBar.Panels[StatusBar.Panels.Count-1].Text := E.Message;
  end;
  if Assigned(MNode) and (csDestroying in MNode.ComponentState) then
    MNode := nil;
  BeginUpdate;
  ActiveObject.Clear;
  ActiveObject.OnChange := {$IFDEF FPC}@{$ENDIF}ComboBoxChange;
  TreeView.Items.Clear;
  Stuff(MNode, '', nil);
  UpdateComboBox(ActiveObject);
  FComboBoxUpdated := False;
  EndUpdate(False);
  TreeView.FullExpand;
  ComboBoxChange(ActiveObject);
  if Assigned(CurrentMNode) then begin
//    TreeView.Items.GetFirstNode.Expand(True);
//   TreeView.Items.GetFirstNode.Selected := True;
//    if CurrentMNode is TStreamableMNode then
//      NewCaption := TStreamableMNode(CurrentMNode).DirectoryName
//    else
//      NewCaption := '';
    NewCaption := { NewCaption + } CurrentMNode.Name + ' - ' + DefaultCaption;
  end else
    NewCaption := DefaultCaption;
  Caption := NewCaption;
  UpdateAlwaysVisible;
end;

procedure TConstantsForm.SymmetryTableItemClick(Sender: TObject);
var
  i: Integer;
  MNode: TMNode;
begin
  for i := 0 to nSelectedNodes - 1 do begin
    MNode := SelectedNode(i);
    if MNode is TState then
      with MNode as TState do begin
        Molecule.Mixture.CheckProperties;
        SymmetryTable(Log);
      end;
  end;
end;

procedure TConstantsForm.ParameterChanged(MNode: TMNode; Index: Integer);
begin
  if CurrentMNode is TCorrelations then
    UpdateCorrelation(TCorrelations(CurrentMNode))
  else if MNode = CurrentMNode then begin
    if Index >= ParGrid.RowCount then
      Exit;
    ParGrid.Lbl[Index] := MNode.ParameterNames[Index];
    ParGrid[Index,1] := MNode.Parameters[Index];
    if MNode is TStringMNode then
      { Skip }
    else begin
      ParGrid.Valid[Index,2] := MNode.Floating[Index];
      if MNode.Increment[Index] <= 0 then
        ParGrid.Valid[Index,3] := False
      else
        ParGrid[Index,3] := MNode.Increment[Index];
      if MNode.StdDev[Index] <= 0 then
        ParGrid.Valid[Index,4] := False
      else
        ParGrid[Index,4] := MNode.StdDev[Index];
    end;
  end;
end;

procedure TConstantsForm.UpdateCorrelation(Correlations: TCorrelations);
  function NameOf(MNode: TMNode; Index: Integer):string;
  begin
    Result := MNode.FullHeirarchicName+'.'+MNode.ParameterNames[Index];
    Delete(Result,1,Length(MNode.RootNode.FullHeirarchicName)+1);
  end;
var
  i, j, n: Integer;
  s: string;
begin
  { Allow for inconsistent value of n during update }
  n := Correlations.nEntries;
  if n = 0 then
    EmptyParGrid
  else begin
    ParGrid.Enabled := True;
    ParGrid.RowCount := n+1;
    ParGrid.FixedRows := 1;
    ParGrid.ColCount := ParGrid.RowCount;
    for i := 0 to n - 1 do begin
      s := Correlations.EntryName(i,False);
      ParGrid.Lbl[i+1] := s;
      ParGrid.Title[i+1] := s;
      for j := 0 to i - 1 do begin
        ParGrid[i+1,j+1] := Correlations.FitDetails.Correlation[i,j];
        ParGrid[j+1,i+1] := Correlations.FitDetails.Correlation[i,j];
      end;
      ParGrid[i+1,i+1] := 1;
    end;
    ParGrid.AutoAdjustColumn(1);
  end;
end;

procedure TConstantsForm.SettingChanged(MNode: TMNode; Index: Integer);
var
  s: string;
begin
  if OptGrid.EditorMode then Exit;
  if MNode = CurrentMNode then begin
    OptGrid.Cells[0,Index-1] := MNode.SettingNames[Index];
    s := MNode.SettingToStr(Index);
    if MNode.IsSettingQuantum(Index) and (s[1] in ['-', '0'..'9']) then
      s := GlobalMixture.QuantumNumberToStr(MNode.Settings[Index]);
    OptGrid.Cells[1,Index-1] := s;
  end;
  CheckForNameChange;
end;

procedure TConstantsForm.ShowItem(MNode: TMNode);
var
  i: Integer;
  procedure EmptyOptGrid;
  begin
    with OptGrid do begin
      FixedRows := 0;
      RowCount := 1;
      Cells[0,0] := '';
      Cells[1,0] := '';
    end;
  end;
  var
    TreeNode: TTreeNode;
begin
  OptGrid.EditorMode := False;
  ParGrid.EditorMode := False;
  if Assigned(CurrentMNode) and (LastError <> '') then begin
    MessageDlg(LastError, mtError, [mbOK], 0);
    LastError := '';
    ShowItem(CurrentMNode);
    OptGrid.Row := LastRow;
    Exit;
  end;
  LastError := '';
  CurrentMNode := nil; { Lockout change notifications }
  if MNode = nil then begin
    EmptyParGrid;
    with ParGrid do begin
      FixedRows := 0;
      RowCount := 1;
    end;
    EmptyOptGrid;
    {$IFDEF LCL_}
    TreeView.Selected := nil;
    {$ELSE}
    TreeView.Select([]);
    {$ENDIF}
    CommentEdit.Text := '';
  end else begin
    TreeNode := FindObject(TreeView,MNode);
    {$IFDEF LCL_}
    TreeView.Selected := TreeNode;
    {$ELSE}
    if TreeView.Selected <> TreeNode then
      TreeView.Select(TreeNode);
    {$ENDIF}
    TreeNode.MakeVisible;
    { Order is important here }
    if MNode is TCorrelations then
      UpdateCorrelation(TCorrelations(MNode))
    else if MNode.nParameters > 0 then begin
      ParGrid.Enabled := True;
      ParGrid.RowCount := MNode.nParameters+1;
      ParGrid.FixedRows := 1;
      if MNode is TStringMNode then
        ParGrid.ColCount := 2
      else begin
        ParGrid.ColCount := 5;
        ParGrid.Title[1] := 'Value';
        ParGrid.Title[2] := 'Float';
        ParGrid.Title[3] := 'Increment';
        ParGrid.Title[4] := 'StdDev';
      end;
    end else
      EmptyParGrid;
    CurrentMNode := MNode;
    for i := 1 to MNode.nParameters do
      ParameterChanged(MNode, i);
    if MNode.nSettings < 1 then
      EmptyOptGrid
    else begin
      OptGrid.RowCount := MNode.nSettings;
      for i := 1 to MNode.nSettings do
        SettingChanged(MNode, i);
      OptGrid.FixedRows := 0;
    end;
    SetItemIndex(ActiveObject,MNode);
    OptGrid.ColWidths[0] := OptGrid.DefaultColWidth;
    OptGrid.AutoAdjustColumn(0,True);
    {$IFNDEF LCL_}
    ParGrid.ColWidths[0] := OptGrid.ColWidths[0];
    if not (MNode is TCorrelations) then
      ParGrid.ColWidths[1] := OptGrid.ColWidths[1];
    {$ENDIF}
    ParGrid.AutoAdjustColumn(0,True);
    for i := 2 to ParGrid.ColCount-1 do
      ParGrid.AutoAdjustColumn(i);
    {$IFDEF LCL_}
    OptGrid.ColWidths[1] := OptGrid.ColWidths[1] + 20;
    {$ENDIF}
    CommentEdit.Text := CurrentMNode.Comment;
  end;
  UpdateAlwaysVisible;
  AdjustSplitters;
end;

procedure TConstantsForm.ParGridGetCellIsFlag(Sender: TObject; Col,  Row: Integer; var IsFlag: Boolean);
begin
  IsFlag := (Col = 2) and not (CurrentMNode is TCorrelations) ;
end;

procedure TConstantsForm.ParGridDblClick(Sender: TObject);
begin
  if (LastCell.Y > 0) and (LastCell.Y < ParGrid.RowCount) then
    {$IFDEF LCL}
    if LastCell.X > 0 then
      TurnOnEditing := True; { Can't turn on EditorMode here, as it gets turned off again by pending messages }
    {$ENDIF}
end;

procedure TConstantsForm.ParGridDrawCellContents(Sender: TObject; ACol,
  ARow: Integer; Rect: TRect; State: TGridDrawState; var Drawn: Boolean);
begin
  if WheelAdjustActive and (ACol = 1) and (ARow = ParGrid.Row) then begin
    ParGrid.Canvas.Font.Style := [fsBold];
    LastBoldRow := ARow;
  end else
    ParGrid.Canvas.Font.Style := [];
end;

procedure TConstantsForm.ParGridMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  ParGrid.MouseToCell(X, Y, LastCell.X, LastCell.Y);
end;

procedure TConstantsForm.AbortMouseAdjustItemClick(Sender: TObject);
begin
  WheelAdjustActive := False;
  if LastAdjustedRow > 0 then begin
    ParGrid.Value[ParGrid.Row, 1] := LastAdjustedValue;
    MainForm.ConsiderReplot;
  end;
  LastAdjustedRow := -1;
end;

procedure TConstantsForm.ParGridMouseWheel(Sender: TObject; Shift: TShiftState;
  WheelDelta: Integer; MousePos: TPoint; var Handled: Boolean);
var
  Increment: Double;
begin
  if WheelAdjustActive and (ParGrid.Row > 0) then begin
    Inc(WheelCount, WheelDelta);
    Handled := True;
    if MainForm.CalculationInProgress then begin
      { Defer }
    end else begin
      if LastAdjustedRow <> ParGrid.Row then begin
        LastAdjustedRow := ParGrid.Row;
        LastAdjustedValue := ParGrid.Value[ParGrid.Row,1];
      end;
      if ParGrid.Valid[ParGrid.Row,3] then
        Increment := ParGrid.Value[ParGrid.Row,3]
      else
        Increment := ParGrid.Value[ParGrid.Row,1] * 0.01;
      if Increment = 0 then
        Increment := 0.1;
      if Abs(WheelCount) >= WHEEL_DELTA then { Fix for Carbon Oddity }
        Increment := IntPower(Increment, Abs(WheelCount) div WHEEL_DELTA);
      if WheelCount < 0 then
        Increment := -Increment;
      ParGrid.Value[ParGrid.Row, 1] := ParGrid.Value[ParGrid.Row, 1] + Increment;
      WheelCount := 0;
      MainForm.ConsiderReplot;
    end;
  end;
end;

procedure TConstantsForm.ParGridChangeCellQuery(Sender: TObject; Col,
  Row: Integer; var CanChange: Boolean);
begin
  { Do not allow number of rows and columns to change }
  CanChange := CanChange and (ParGrid.FixedRows > 0)
               and (Row < ParGrid.RowCount) and (Col < ParGrid.ColCount);
  if CanChange and (CurrentMNode is TCorrelations) then
    CanChange := Row <> Col;
end;

procedure TConstantsForm.CopyWithLabelsItemClick(Sender: TObject);
begin
  ParGrid.CopyToClipboard(True);
end;

procedure TConstantsForm.ParGridChanged(Sender: TObject; Col, Row: Integer);
begin
  if Assigned(CurrentMNode) and (Row > 0) then
    if CurrentMNode is TCorrelations then
      if Row = Col then
        ParGrid[Col,Row] := 1
      else begin
        if (Row > 0) and (Col > 0) then begin
          if Row > Col then
            TCorrelations(CurrentMNode).FitDetails.Correlation[Row-1,Col-1] := ParGrid[Row, Col];
          if ParGrid[Col,Row] <> ParGrid[Row,Col] then
            ParGrid[Col,Row] := ParGrid[Row,Col];
        end;
      end
    else
      case Col of
        1: CurrentMNode.SetParameter(Row, ParGrid[Row, Col]);
        2: CurrentMNode.Floating[Row] := ParGrid.Valid[Row, Col];
        3: if ParGrid.Valid[Row, Col] and (ParGrid[Row, Col] > 0) then
             CurrentMNode.Increment[Row] := ParGrid[Row, Col]
           else begin
             CurrentMNode.Increment[Row] := 0;
             ParGrid.Valid[Row,Col] := False;
           end;
        4: if ParGrid.Valid[Row, Col] and (ParGrid[Row, Col] > 0) then
             CurrentMNode.StdDev[Row] := ParGrid[Row, Col]
           else begin
             CurrentMNode.StdDev[Row] := 0;
             ParGrid.Valid[Row,Col] := False;
           end;
      end;
end;

procedure TConstantsForm.FormCreate(Sender: TObject);
begin
  {$IFDEF LCL_}
  ParGrid.Options := ParGrid.Options + [goDblClickAutoSize];
  OptGrid.Options := ParGrid.Options + [goDblClickAutoSize];
  TreeView.OnSelectionChanged := @TreeViewSelectionChanged;
  StatusBar.SimplePanel := False;
  FixAllButton.Width := FixAllButton.Width + 4;
  ConvertUnitsButton.Width := ConvertUnitsButton.Width + 4;
  FixAllButton.Flat := False;
  ConvertUnitsButton.Flat := False;
  {$ENDIF}
  ParGrid.OnGetCellIsFlag := {$IFDEF FPC}@{$ENDIF}ParGridGetCellIsFlag;
end;

procedure TConstantsForm.FormDestroy(Sender: TObject);
begin
  if ConstantsForm = Self then
    ConstantsForm := nil;
end;

procedure TConstantsForm.FormHide(Sender: TObject);
begin
  ParGrid.EditorMode := False;
  OptGrid.EditorMode := False;
end;

procedure TConstantsForm.FormResize(Sender: TObject);
begin
  if SplitL.Align in [alLeft, alRight] then begin
    if  Height > Width *1.2 then
      FlipOrientation;
  end else if Width > Height*1.2 then
    FlipOrientation;
  AdjustSplitters;
//  SplitL.ParentResized;
//  SplitR.ParentResized;
  {$IFDEF LCL_}
  AlControl(nil);
  AlControl(Label1);
  AlControl(CommentEdit);
  {$ENDIF}
end;

procedure TConstantsForm.HandleControl(Control: TControl; var PName, Value,
  PHint: string; var Save: Boolean; var SettingType: TSettingType; Write: Boolean);
begin
  if Control = ActiveObject then
    inherited;
end;

function TConstantsForm.nSelectedNodes: Integer;
{$IFNDEF VCL_}
var
  Node: TTreeNode;
{$ENDIF}
begin
  {$IFDEF VCL_}
  Result := TreeView.SelectionCount
  {$ELSE}
  Result := 0;
  Node := TreeView.GetFirstMultiSelected;
  while Assigned(Node) do begin
    Inc(Result);
    Node := Node.GetNextMultiSelected;
  end;
  if (Result = 0) and Assigned(CurrentMNode) then
    Inc(Result);
  {$ENDIF}
end;

function TConstantsForm.SelectedNode(Index: Integer): TMNode;
var
  Node: TTreeNode;
begin
  Result := nil;
  {$IFDEF VCL_}
  Node := TreeView.Selections[Index];
  {$ELSE}
  Node := TreeView.GetFirstMultiSelected;
  if not Assigned(Node) and (Index = 0) then begin
    Result := CurrentMNode;
    Exit;
  end else
    while (Index > 0) and Assigned(Node) do begin
      Dec(Index);
      Node := Node.GetNextMultiSelected;
    end;
  {$ENDIF}
  if Assigned(Node) then
    Result := MNodeFromTreeNode(Node);
end;

procedure TConstantsForm.TreeViewChange(Sender: TObject; Node: TTreeNode);
var
  MNode: TMNode;
begin
  MNode := MNodeFromTreeNode(Node);
  CheckForNameChange;
  ShowItem(MNode);
end;

procedure TConstantsForm.TreeViewCustomDrawItem(Sender: TCustomTreeView;
  Node: TTreeNode; State: TCustomDrawState; var DefaultDraw: Boolean);
var
  MNode: TMNode;
  Colour: TColor;
begin
  MNode := MNodeFromTreeNode(Node);
  if Assigned(MNode) and not (cdsSelected in State) then begin
    Colour := clNone;
    { TODO: sensible class method for this }
    if MNode is TState then
      Colour := TState(MNode).Colour
    else if MNode is TTransitionMoments then
      Colour := TTransitionMoments(MNode).Colour
    else if MNode is TMolecule then
      Colour := TMolecule(MNode).Colour
    else if MNode is TManifold then
      Colour := TManifold(MNode).Colour
    else if MNode is TSpecies then
      Colour := TSpecies(MNode).Colour
    else if MNode is TPlot then
      Colour := TPlot(MNode).Colour;
    if IsVisibleColour(Colour) then
      TreeView.Canvas.Font.Color := Colour
    else
      TreeView.Canvas.Font.Color := clBlack;
  end;
end;

{$IFDEF LCL_}
procedure TConstantsForm.TreeViewSelectionChanged(Sender: TObject);
begin
  TreeViewChange(Sender, TreeView.Selected);
end;
{$ENDIF}

procedure TConstantsForm.TreeViewEdited(Sender: TObject; Node: TTreeNode; var S: String);
begin
  CurrentMNode := MNodeFromTreeNode(Node);
  if not Assigned(CurrentMNode) then
    Exit;
  S := Trim(S);
  BeginUpdate;
  try
    CurrentMNode.Name := S;
    RenameForm.RenameMNodePairsAsRequired(CurrentMNode.RootNode, False);
  finally
    EndUpdate(False, True);
  end;
end;

procedure TConstantsForm.RenameItemClick(Sender: TObject);
{$IFDEF LCL_}
var
  s: string;
{$ENDIF}
begin
  if Assigned(CurrentMNode) then
    if CurrentMNode is TMNodePair then
      RenameForm.Rename(CurrentMNode as TMNodePair)
    else begin
      {$IFDEF LCL_}
      { TODO: Remove when LCL implements inplace rename }
      s := CurrentMNode.Name;
      if InputQuery('Rename Item', 'New Name:', s) then
        TreeViewEdited(nil, FindObject(TreeView,CurrentMNode), s);
      {$ELSE}
      TreeView.Selected.EditText;
      {$ENDIF}
    end;
end;

procedure TConstantsForm.OptGridSetEditText(Sender: TObject; ACol,
  ARow: Integer; const Value: String);
var
  Q: TQuantumNumber;
begin
  if Assigned(CurrentMNode) and (ACol = 1) and (Trim(OptGrid.Cells[ACol, ARow]) <> '') then
    try
      LastError := '';
      try
        BeginUpdate;
        if CurrentMNode.IsSettingQuantum(ARow+1)
           and TryStrToQuantumNumber(OptGrid.Cells[ACol, ARow], Q, GlobalMixture.QuantumNumberFormat) then
          CurrentMNode.Settings[ARow+1] := Q
        else if CurrentMNode.IsSettingColour(ARow+1) then
          CurrentMNode.Settings[ARow+1] := StrToColour(Value,True) { Prompt for colour if Other... }
        else
          CurrentMNode.SetSettingFromStr(ARow+1, OptGrid.Cells[ACol, ARow]);
        if Pos('...', Value) > 0 then
          OptGrid.Cells[ACol, ARow] := CurrentMNode.SettingToStr(ARow+1);
      finally
        EndUpdate(False);
      end;
    except
      on E: Exception do begin
        LastRow := ARow;
        LastError := E.Message;
        StatusBar.Panels[StatusBar.Panels.Count-1].Text := E.Message;
      end;
    end;
end;

procedure TConstantsForm.FixAllButtonClick(Sender: TObject);
begin
  if Assigned(BaseNode) then
    BaseNode.FixAll(True);
end;

procedure TConstantsForm.FlipOrientation;
  function ShiftCon(Control: TControl):Integer;
  begin
    if akLeft in Control.Anchors then begin
      Control.Anchors := (Control.Anchors - [akLeft]) + [akRight];
      Result := Control.Left;
    end else begin
      Control.Anchors := (Control.Anchors - [akRight]) + [akLeft];
      Result := Control.Left + Control.Width;
    end;
  end;
var
  W, NewTop: Integer;
begin
  Panel.DisableAlign;
  if SplitL.Align in [alLeft, alRight] then begin
    { Switch to narrow form - controls in panel in two lines }
    NewTop := 2*SelectorComboBoxTop + ActiveObject.Height;
    Panel.Height := NewTop + ActiveObject.Height + SelectorComboBoxTop;
    Panel.Top := 0;
    ActiveObject.Top := 2*SelectorComboBoxTop + ActiveObject.Height;
    ActiveObject.Width := Panel.Width - 2*MarginSize;
    ActiveObject.Left := MarginSize;
    FixAllButton.Left := SelectorComboBoxLeft;
    ConvertUnitsButton.Left := ShiftCon(FixAllButton);
    UnitsLabel.Left := ShiftCon(ConvertUnitsButton) + 4;
    ShiftCon(UnitsLabel);
  end else begin
    { Switch to wide form - controls in panel in one line};
    UnitsLabel.Left := Panel.Width-MarginSize-UnitsLabel.Width;
    ConvertUnitsButton.Left := ShiftCon(UnitsLabel)-MarginSize-ConvertUnitsButton.Width;
    FixAllButton.Left := ShiftCon(ConvertUnitsButton)-FixAllButton.Width;
    ShiftCon(FixAllButton);
    ActiveObject.Top := SelectorComboBoxTop;
    ActiveObject.Left := SelectorComboBoxLeft;
    ActiveObject.Width := FixAllButton.Left - ActiveObject.Left - MarginSize;
    Panel.Height := ActiveObject.Top + ActiveObject.Height + SelectorComboBoxTop;
  end;
  Panel.EnableAlign;
  if SplitL.Align in [alLeft, alRight] then begin
    W := TreeView.Height;
    Constraints.MinHeight := 300;
  end else begin
    W := TreeView.Width;
    Constraints.MinHeight := 200;
  end;
  SplitL.Flip(W div 3, 2 * W div 3);
  SplitR.Flip(2 * W div 3);
end;

function TConstantsForm.DefaultCaption: string;
begin
  Result := 'Constants';
end;

procedure TConstantsForm.ConvertUnitsButtonClick(Sender: TObject);
begin
  if Assigned(CurrentMNode) then begin
    FormDeactivate(nil);
    CurrentMNode.CycleUnits;
  end;
end;

procedure TConstantsForm.OptGridGetEditStyle(Sender: TObject; ACol, ARow: Integer; var Style: TEditStyle);
begin
  if Assigned(CurrentMNode) and CurrentMNode.IsSettingEnum(ARow+1) then
    Style := esPickList;
end;

procedure TConstantsForm.OptGridGetPickListItems(ACol, ARow: Integer; Items: TStrings);
begin
  if Assigned(CurrentMNode) then
    CurrentMNode.GetEnumNames(ARow+1, Items);
end;

procedure TConstantsForm.CopyItemClick(Sender: TObject);
begin
  CopyItemsToClipboard(False);
end;

procedure TConstantsForm.CopyItemsToClipboard(LinkedItems: Boolean);
var
  i: Integer;
  MNodeList: TObjectList;
begin
  if nSelectedNodes > 1 then begin
    { Prepare list of items to put on the clipboard }
    MNodeList := TObjectList.Create(False);
    try
      for i := 0 to nSelectedNodes - 1 do
        if LinkedItems then
          SelectedNode(i).LinkedNodesList(MNodeList)
        else
          MNodeList.Add(SelectedNode(i));
      SelectedNode(0).CopyToClipboard(True,MNodeList);
    finally
      MNodeList.Free;
    end;
  end else if Assigned(CurrentMNode) then
    CurrentMNode.CopyToClipboard(LinkedItems);
end;

procedure TConstantsForm.CopyWithLinkedItemsItemClick(Sender: TObject);
begin
  CopyItemsToClipboard(True);
end;

procedure TConstantsForm.TreePopupMenuPopup(Sender: TObject);
var
  i: Integer;
  MenuItem: TMenuItem;
  GlobalSetting, Linked: Boolean;
  MNodeClass: TMNodeClass;
  procedure CheckNode(MNode: TMNode);
  begin
    GlobalSetting := GlobalSetting or ((MNode is TNucleus) or (MNode is TBaseVibrationalMode));
    Linked := Linked or (MNode.LinkedNodesList > 0);
  end;
begin
  if Assigned(TreeView.Selected) then
    TreeView.Selected.Selected := True;
  GlobalSetting := False;
  Linked := False;
  if nSelectedNodes > 1 then
    for i := 0 to nSelectedNodes - 1 do
      CheckNode(SelectedNode(i))
  else if Assigned(CurrentMNode) then
    CheckNode(CurrentMNode);
  CopyWithLinkedItemsItem.Visible := Assigned(CurrentMNode) and not GlobalSetting and Linked;
  PasteItem.Enabled := Clipboard.HasFormat(MNodeClipboardFormat);
  MoveUpItem.Enabled := MoveUpDown(-1,True);
  MoveDownItem.Enabled := MoveUpDown(+1,True);
  ConvertItem.Visible := CurrentMNode is TState;
  DeleteItem.Enabled := not GlobalSetting;
  AllMatrixElementsItem.Visible := (CurrentMNode is TState) or (CurrentMNode is TPerturbation);
  SymmetryTableItem.Visible := CurrentMNode is TState;
  AddAllLevelsTreeItem.Visible := (CurrentMNode is TManifold) or (CurrentMNode is TState);
  if Assigned(CurrentMNode)
     and (CurrentMNode.nChildTypes > 0) and Assigned(CurrentMNode.GetChildTypes(0))
     then begin
    AddNewItem.Enabled := True;
    AddNewItem.Clear;
    if CurrentMNode.nChildTypes > 1 then begin
      AddNewItem.Caption := '&Add new ...';
      AddNewItem.Tag := -1;
      for i := 0 to CurrentMNode.nChildTypes-1 do begin
        MNodeClass := CurrentMNode.GetChildTypes(i);
        if Assigned(MNodeClass) and CurrentMNode.IsValidChildClass(MNodeClass)
           and not MNodeClass.InheritsFrom(TFormSettings)
           and (not MNodeClass.InheritsFrom(TPlot) or MNodeClass.InheritsFrom(TCalculatedSource)) then begin
          MenuItem := TMenuItem.Create(AddNewItem);
          MenuItem.Caption := CurrentMNode.GetChildTypes(i).DisplayClassName;
          MenuItem.Hint := 'Add new object'; { TODO: Make F1 work }
          MenuItem.Tag := i;
          MenuItem.OnClick := {$IFDEF FPC}@{$ENDIF}AddNewItemClick;
          AddNewItem.Add(MenuItem);
        end;
      end;
      if CurrentMNode is TOverlays then
        StuffCalibrationMenu(AddNewItem,{$IFDEF FPC}@{$ENDIF}MainForm.I2ItemClick);
    end else begin
      AddNewItem.Tag := 0;
      AddNewItem.Caption := '&Add new ' + CurrentMNode.GetChildTypes(0).DisplayClassName;
    end;
  end else begin
    AddNewItem.Caption := '&Add new ...';
    AddNewItem.Enabled := False;
  end;
  { Add MNode specific items; could shift some of the above logic to this }
  with TreePopupMenu.Items do begin
    if nInitialTreeMenuItems = 0 then
      nInitialTreeMenuItems := Count;
    while Count > nInitialTreeMenuItems do
      Delete(Count-1);
  end;
  if nSelectedNodes = 1 then { TODO: Implement multiple handler }
    CurrentMNode.AddHandlersToMenu(TreePopupMenu.Items);
end;

procedure TConstantsForm.PasteItemClick(Sender: TObject);
begin
  PasteItemsIntoTree;
end;

procedure TConstantsForm.DeleteItemClick(Sender: TObject);
var
  i, Ans, LinkedAns: Integer;
  DoReplot: Boolean;
  MNode, NextMNode: TMNode;
  MNodeList: TComponentList;
begin
  DoReplot := False;
  NextMNode := nil;
  MNodeList := TComponentList.Create(False);
  LinkedAns := mrNo;
  Ans := mrNo;
  BeginUpdate;
  try
    for i := nSelectedNodes-1 downto 0 do begin
      MNode := SelectedNode(i);
      if MNodeList.IndexOf(MNode) < 0 then begin
        { If not already flagged for deletion }
        if MNode.LinkedNodesList > 0 then begin
          if not (LinkedAns in [mrYesToAll, mrNoToAll]) then
            LinkedAns := MessageDlg(MNode.UniqueName + ' has linked nodes. Delete these also?', mtConfirmation,
                                   [mbYes, mbYesToAll, mbNo, mbNoToAll, mbCancel],0);
          case LinkedAns of
            mrYes, mrYesToAll: MNode.LinkedNodesList(MNodeList);
            mrNo, mrNoToAll:   MNodeList.Add(MNode);
            mrCancel:          Exit;
          end;
        end else begin
          if Ans <> mrYesToAll then
            Ans := MessageDlg('Are you sure you want to delete ' + MNode.UniqueName + '?', mtConfirmation,
                              [mbYes, mbYesToAll, mbNo, mbCancel],0);
          case Ans of
            mrYes, mrYesToAll: MNodeList.Add(MNode);
            mrCancel:          Exit;
          end;
        end;
      end;
      DoReplot := DoReplot or (MNode is TPlot);
      if MNodeList.IndexOf(MNode) >= 0 then
        NextMNode := MNode; { Remember last deleted selected item }
    end;
    if Assigned(NextMNode) then begin
      MNode := NextMNode;
      NextMNode := NextMNode.Owner as TMNode;
      { Find next active node after last deleted item }
      if MNode.ComponentIndex < NextMNode.ComponentCount-1 then { Take node below }
        NextMNode := NextMNode.Components[CurrentMNode.ComponentIndex+1] as TMNode
      else if MNode.ComponentIndex > 0 then { Take node above }
        NextMNode := NextMNode.Components[CurrentMNode.ComponentIndex-1] as TMNode;
    end;
    CurrentMNode := NextMNode;
    MNodeList.OwnsObjects := True; { Force delete items in next line }
  finally
    MNodeList.Free;
    EndUpdate;
  end;
  if DoReplot then
    MainForm.ConsiderReplot;
end;

procedure TConstantsForm.TreeViewKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
  {$IFDEF LCL_}
  if (Key in [VK_UP, VK_DOWN]) and (Shift = [ssAlt]) then begin
    { Handle here as LCL treats key as navigation key }
    MoveUpDown(IfThen(Key=VK_DOWN,1,-1),False);
    Key := VK_UNKNOWN;
  end;
  {$ENDIF}
end;

procedure TConstantsForm.TreeViewMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  if (Button = mbRight) and Assigned(TreeView.Selected) then
    TreeView.Selected.Selected := True;
end;

procedure TConstantsForm.TurnonMouseAdjustItemClick(Sender: TObject);
begin
  WheelAdjustActive:= not WheelAdjustActive;
  LastAdjustedRow := -1;
  ParGrid.InvalidateCol(1);
end;

function TConstantsForm.BaseNodeClass: TClass;
begin
  Result := TMixture;
end;

function TConstantsForm.StuffObject(const Name1, Name2: string; MNode: TMNode; var ParentNode: TTreeNode): Integer;
begin
  ActiveObject.AddItem(Name1 + Name2, MNode);
  Result := ActiveObject.Items.Count-1;
  {$IFDEF LCL_}
  ParentNode := TreeView.Items.AddChildObject(ParentNode, Name2, MNode);
  {$ELSE}
  ParentNode := TreeView.Items.AddNode(nil, ParentNode, Name2, MNode, naAddChild);
  {$ENDIF}
end;

procedure TConstantsForm.CheckForNameChange;
begin
  if Visible and Assigned(CurrentMNode) and  (CurrentMNode.UniqueName <> CurrentMNodeName) then
    ReStuff;
end;

{$IFDEF LCL_}
type
  TOpenCustomGrid = class(TCustomGrid)
  end;
{$ENDIF}
procedure TConstantsForm.UpdateActions;
begin
  inherited UpdateActions;
  if Visible and not (ParGrid.EditorMode or OptGrid.EditorMode) then begin
    CheckForNameChange;
    if (CurrentMNode is TCorrelations) and (TCorrelations(CurrentMNode).nEntries+1 <> ParGrid.RowCount) then
      UpdateCorrelation(TCorrelations(CurrentMNode));
    {$IFDEF LCL_}
    if TurnOnEditing and ((ActiveControl = ParGrid) or (ActiveControl = OptGrid)) then
      TOpenCustomGrid(ActiveControl).EditorMode := True;
    {$ENDIF}
  end;
  {$IFDEF LCL_}
  TurnOnEditing := False;
  {$ENDIF}
end;

procedure TConstantsForm.FormDeactivate(Sender: TObject);
begin
  ParGrid.EditorMode := False;
  OptGrid.EditorMode := False;
end;

procedure TConstantsForm.PropNameChanged(MNode: TMNode; Index: Integer);
var
  i: Integer;
begin
  for i := 1 to CurrentMNode.nSettings do
    if OptGrid.Cells[0,i-1] <> MNode.SettingNames[i] then
       OptGrid.Cells[0,i-1] := MNode.SettingNames[i];
  for i := 1 to MNode.nParameters do
    if ParGrid.Lbl[i] <> MNode.ParameterNames[i] then
      ParGrid.Lbl[i] := MNode.ParameterNames[i];
end;

procedure TConstantsForm.CommentEditChange(Sender: TObject);
begin
  if Assigned(CurrentMNode) then
    CurrentMNode.Comment := CommentEdit.Text;
end;

procedure TConstantsForm.MatrixElementsItemClick(Sender: TObject);
var
  i,j: Integer;
  Elements: TMatrixElements;
begin
  ReShow(LogForm);
  for i := ParGrid.Selection.Top to ParGrid.Selection.Bottom do
    with CurrentMNode as TState do begin
      Writeln(Log, 'Matrix Elements of ', ParameterNames[i], ' in ',  UniqueName);
      TStart(IndividualSymbolicRotationalMatrixElementTime);
      Elements := SymbolicRotationalMatrixElement(i);
      TEnd(IndividualSymbolicRotationalMatrixElementTime);
      for j := 0 to High(Elements) do
        WriteLn(Log, MatrixElementType(Elements[j].Signature, ParameterNames[i]), ' = ', Elements[j].Expr.Text(True));
      DiscardMatrixElements(Elements);
      WriteLn(Log);
    end;
end;

procedure TConstantsForm.ShowFullNameItemClick(Sender: TObject);
var
  s: string;
begin
  if Assigned(CurrentMNode) then begin
    s := CurrentMNode.FullParameterName(ParGrid.Row);
    ShowInfo('Parameter Name is ' + s);
    Clipboard.AsText := s;
  end;
end;

procedure TConstantsForm.ConverttoPerturbationItemClick(Sender: TObject);
var
  i: Integer;
begin
  BeginUpdate;
  for i := ParGrid.Selection.Top to ParGrid.Selection.Bottom do
    with CurrentMNode as TState do
      ConvertParameter(i,True);
  EndUpdate;
end;

procedure TConstantsForm.AllMatrixElementsItemClick(Sender: TObject);
var
  i, j, k: Integer;
  Elements: TMatrixElements;
  MNode: TMNode;
begin
  ReShow(LogForm);
  for i := 0 to nSelectedNodes - 1 do begin
    MNode := SelectedNode(i);
    if MNode is TPerturbation then
      with MNode as TPerturbation do begin
        Writeln(Log, 'Matrix Elements of ', Name);
        TStart(IndividualSymbolicRotationalMatrixElementTime);
        Elements := SymbolicMatrixElements;
        TEnd(IndividualSymbolicRotationalMatrixElementTime);
        for j := 0 to High(Elements) do
          WriteLn(Log, (Bra as TState).MatrixElementType(Elements[j].Signature, PairName), ' = ', Elements[j].Expr.Text(True));
        WriteLn(Log);
        DiscardMatrixElements(Elements);
      end
    else if MNode is TState then
      with MNode as TState do begin
        CheckMatrixElementsAvailable;
        Writeln(Log, 'Matrix Elements in ',  UniqueName);
        for j := 0 to High(MatrixElements) do begin
          WriteLn(Log, MatrixElementType(MatrixElements[j].Signature, 'H'), ' = ');
          with MatrixElements[j].Expr do
            if Base = OperatorPlus then
              for k := 0 to nChildren-1 do
                WriteLn(Log, '+  ', Children[k].Text(True))
            else
              WriteLn(Log, '   ', Text(True))
        end;
        WriteLn(Log);
      end;
  end;
end;

procedure TConstantsForm.ArrangeForm(Screen: TRect);
var
  MainRect, NewRect: TRect;
begin
  inherited;
  MainRect := ScreenBounds(MainForm);
  NewRect := Rect(MainRect.Right, MainRect.Top, Screen.Right, MainRect.Bottom);
  with NewRect do
    if Right - Left < 200 then
      Left := Right - 200;
  if OverlayForm.Visible and ConstantsForm.Visible then begin
    with NewRect do
      Bottom := (Top+Bottom) div 2;
    SetScreenBounds(ConstantsForm, NewRect);
    with NewRect do begin
      Top := Bottom;
      Bottom := MainRect.Bottom;
    end;
    SetScreenBounds(OverlayForm, NewRect);
  end else
    SetScreenBounds(Self, NewRect);
end;

procedure TConstantsForm.MNodeChange(Sender: TMnode; Change: TMNodeChange; Index: Integer);
begin
  inherited;
  UpdateAlwaysVisible;
end;

function TConstantsForm.MNodeFromTreeNode(TreeNode: TTreeNode): TMNode;
begin
  if Assigned(TreeNode) and Assigned(BaseNode) and not (csDestroying in BaseNode.ComponentState) then
    Result := TMNode(TreeNode.Data)
  else
    Result := nil;
  if Assigned(Result) then
    if not Result.IsValidChildOf(BaseNode) or (csDestroying in Result.ComponentState) then
      Result := nil
end;

procedure TConstantsForm.UpdateAlwaysVisible;
begin
  { Special call for variable that is always visible }
  if Visible and Assigned(BaseNode) then
    UnitsLabel.Caption := (BaseNode as TUnitsMNode).UnitsName;
end;

function TConstantsForm.MoveUpDown(Shift: Integer; Test: Boolean): Boolean;
var
  SelectedNodes: array of TMNode;
  OriginalIndex: array of Integer;
  i, j: Integer;
  Moved: Boolean;
  Node: TTreeNode;
  List: TList;
begin
  Result := False;
  SetLength(SelectedNodes,nSelectedNodes);
  if Length(SelectedNodes) = 0 then
    Exit;
  SetLength(OriginalIndex,Length(SelectedNodes));
  for i := 0 to Length(SelectedNodes) - 1 do begin
    SelectedNodes[i] := SelectedNode(i);
    OriginalIndex[i] := SelectedNodes[i].ComponentIndex;
    if not SelectedNodes[i].CanShift(Shift) then
      Exit;
  end;
  Result := True;
  if Test then
    Exit;
  for j := 0 to Length(SelectedNodes) do begin
    { Repeatedly apply the shift to avoid the need to apply the shifts in order }
    Moved := False;
    for i := 0 to Length(SelectedNodes) - 1 do
      if SelectedNodes[i].ComponentIndex <> OriginalIndex[i]+Shift then begin
        SelectedNodes[i].ComponentIndex := OriginalIndex[i]+Shift;
        Moved := True;
      end;
    if not Moved then
      Break;
  end;
  ReStuff;
  { Reselect nodes }
  List := TList.Create;
  try
    Node := TreeView.TopItem;
    while Assigned(Node) do begin
      for i := 0 to High(SelectedNodes) do
        if SelectedNodes[i] = TMNode(Node.Data) then begin
          {$IFDEF LCL_}
          Node.MultiSelected := True;
          {$ELSE}
          List.Add(Node);
          {$ENDIF}
          Break;
        end;
      Node := Node.GetNext;
    end;
    {$IFNDEF LCL_}
    TreeView.Select(List);
    {$ENDIF}
  finally
    List.Free;
  end;
end;

procedure TConstantsForm.MoveUpItemClick(Sender: TObject);
begin
  MoveUpDown(-1,False);
end;

procedure TConstantsForm.MoveDownItemClick(Sender: TObject);
begin
  MoveUpDown(+1,False);
end;

constructor TConstantsForm.Create(AOwner: TCOmponent);
begin
  inherited;
  SelectorComboBoxTop := ActiveObject.Top;
  SelectorComboBoxLeft := ActiveObject.Left;
  MarginSize := ActiveObject.Left;
  {$IFNDEF VCL_}
  TreeView.ScrollBars := ssAutoBoth; { Equivalent in Delphi is not adjustable }
  TreeView.Options := TreeView.Options + [tvoAllowMultiselect];
  {$ENDIF}
  ParGrid.OnMouseWheel := {$IFDEF FPC}@{$ENDIF}ParGridMouseWheel;
end;

{$IFDEF VCL_}
type
  TOpenCustomGrid = class(TCustomGrid)
  end;

procedure TConstantsForm.WMHelp(var Message: TWMHelp);
var
  InPlaceEditor: Boolean;
  function Involves(Control: TWinControl):Boolean;
  begin
    Result := True;
    InPlaceEditor := False;
    if Control.Handle <> Message.HelpInfo.hItemHandle then
      if Control.Handle <>  GetParent(Message.HelpInfo.hItemHandle) then
        Result := False { Inplace editor }
      else
        InPlaceEditor := True;
  end;
  function TryGrid(Grid: TCustomGrid):Boolean;
  var
    Point: TPoint;
    Coord: TGridCoord;
    BookMark: string;
  begin
    Result := Involves(Grid);
    if not Result then Exit;
    if InContextHelp and not InPlaceEditor then begin
      Point := Grid.ScreenToClient(Message.HelpInfo.MousePos);
      Coord := Grid.MouseCoord(Point.X, Point.Y);
    end;
    if not InContextHelp or InPlaceEditor or (Coord.Y < TOpenCustomGrid(Grid).FixedRows) or (Coord.Y > TOpenCustomGrid(Grid).RowCount) then
      Coord.Y := TOpenCustomGrid(Grid).Row;
    if Grid = ParGrid then
      BookMark := CurrentMnode.ParameterNames[Coord.Y]
    else
      BookMark := CurrentMNode.SettingNames[Coord.Y+1];
    Application.HelpSystem.ShowTopicHelp(CurrentMnode.PageName+'.htm#'
                                         +BookMark, Application.CurrentHelpFile);
  end;
  function TryTreeView(TreeView: TTreeView):Boolean;
  var
    TreeNode: TTreeNode;
    MNode: TMnode;
    Point: TPoint;
  begin
    Result := Involves(TreeView);
    MNode := nil;
    if InContextHelp then begin
      Point := TreeView.ScreenToClient(Message.HelpInfo.MousePos);
      TreeNode := TreeView.GetNodeAt(Point.X, Point.Y);
      if Assigned(TreeNode) then
        MNode := MNodeFromTreeNode(TreeNode);
    end;
    if not Assigned(MNode) then
      MNode := CurrentMNode;
    Application.HelpSystem.ShowTopicHelp(Copy(MNode.ClassType.ClassName,2,255)+'.htm',
                                         Application.CurrentHelpFile);
  end;
begin
  if InHelp then Exit;
  if not (csDesigning in ComponentState)
     and (Message.HelpInfo.iContextType = HELPINFO_WINDOW)
     and Assigned(CurrentMNode) then begin
    if TryGrid(ParGrid) or TryGrid(OptGrid) then
      Exit;
    if TryTreeView(TreeView) then
      Exit;
  end;
  inherited;
end;
{$ENDIF}

procedure TConstantsForm.ParGridSelectCell(Sender: TObject; ACol, ARow: Integer;
  var CanSelect: Boolean);
begin
  if Assigned(CurrentMNode) and not(CurrentMNode is TCorrelations) then
    case ACol of
      1: StatusBar.Panels[StatusBar.Panels.Count-1].Text := CurrentMNode.HelpOnParameter(ARow);
      2: StatusBar.Panels[StatusBar.Panels.Count-1].Text := 'Allow parameter to float in least squares fits';
      3: StatusBar.Panels[StatusBar.Panels.Count-1].Text := 'Increment to use for numerical derivatives in least squares fits (blank for default)';
      4: StatusBar.Panels[StatusBar.Panels.Count-1].Text := 'Standard Deviation of parameter from last fit';
    end;
  if WheelAdjustActive and (ACol <> 1) and (ARow <> LastBoldRow) then
    ParGrid.InvalidateCol(1);
end;

procedure TConstantsForm.ParGridExit(Sender: TObject);
begin
  StatusBar.Panels[StatusBar.Panels.Count-1].Text := '';
  CheckForNameChange;
end;

procedure TConstantsForm.OptGridSelectCell(Sender: TObject; ACol, ARow: Integer;
  var CanSelect: Boolean);
begin
  if Assigned(CurrentMNode) then
    StatusBar.Panels[StatusBar.Panels.Count-1].Text := CurrentMNode.HelpOnSetting(ARow+1);
  CheckForNameChange;
end;

procedure TConstantsForm.AddAllLevelsItemClick(Sender: TObject);
var
  Manifold: TManifold;
  i: Integer;
begin
  for i := 0 to nSelectedNodes - 1 do begin
    Manifold := SelectedNode(i).AncestorWithClass(TManifold) as TManifold;
    if Assigned(Manifold) then
      Manifold.AddAllLevels(CurrentMNode.AncestorWithClass(TState) as TState);
  end;
  ReStuff;
end;

procedure TConstantsForm.RemoveAllLevelsItemClick(Sender: TObject);
begin
  with TManifold(CurrentMNode) do
    while nParameters > 0 do
      DeleteParameter(nParameters);
  ReStuff;
end;

procedure TConstantsForm.RemoveItemClick(Sender: TObject);
var
  i: Integer;
begin
  BeginUpdate;
  if (CurrentMNode is TManifold) or (CurrentMNode is TVariables) then
    for i := ParGrid.Selection.Bottom downto ParGrid.Selection.Top do
      CurrentMNode.DeleteParameter(i);
  EndUpdate;
end;

procedure TConstantsForm.AddParameterItemClick(Sender: TObject);
var
  s: string;
begin
  BeginUpdate;
  s := '';
  if InputQuery('Add Parameter','Parameter Name', s) then
    CurrentMNode.AddParameter(Trim(s));
  EndUpdate;
end;

procedure TConstantsForm.AddNewItemClick(Sender: TObject);
var
  MNode: TMNode;
  RenameOK: Boolean;
  s: string;
  {$IFDEF LCL}
  i: Integer;
  {$ENDIF}
begin
  if Assigned(CurrentMNode) then
    with Sender as TMenuItem do
      if Tag >= 0 then begin
        BeginUpdate;
        if CurrentMNode.GetChildTypes(Tag).InheritsFrom(TNucleus) then
          with (CurrentMNode as TState).Molecule do
            nNuclei := nNuclei + 1
        else if CurrentMNode.GetChildTypes(Tag).InheritsFrom(TBaseVibrationalMode) then
          with CurrentMNode.Owner.Owner as TVibratingMolecule do
            nModes := nModes + 1
        else begin
          MNode := CurrentMNode.GetChildTypes(Tag).Create(CurrentMNode);
          if not (MNode is TMNodePair) and not (MNode is TCalibrationSource) then begin
            MNode.AdjustDefaults;
            s := MNode.DisplayClassName;
            if Assigned(CurrentMNode.RootNode.ComponentWithName(s,TMNode,nil,True)) then
              s := 'New ' + s;
            MNode.Name := s;
          end;
          try
            RenameOK := RenameForm.RenameMNodePairsAsRequired(MNode, True);
          except
            MNode.Free;
            raise;
          end;
          if RenameOK then begin { Cancel => MNode no longer valid }
            if MNode.InheritsFrom(TSphericalTransitionMoment) then
              (MNode as TSphericalTransitionMoment).SetSettingFromStr(MNode.IndexOfSetting('Component'),'auto');
            {$IFDEF LCL}
            if MNode is TMNodePair then begin
              { LCL has problems with treeview items with identical names, so shift new node to
                top if necessary }
              s := MNode.UniqueName;
              for i := 0 to CurrentMNode.Count-1 do
                if (CurrentMNode.Items[i] <> MNode) and (CurrentMNode.Items[i].UniqueName = s) then begin
                  MNode.ComponentIndex := 0;
                  ReStuff;
                  Break;
                end;
            end;
            {$ENDIF}
            CurrentMNode := MNode;
          end;
        end;
        EndUpdate;
      end;
end;

type
  TOpenGrid = class(TCustomGrid);

procedure TConstantsForm.AdjustSplitters;
var
  TreeViewSize, ParGridSize, OptGridSize: Integer;
  Available: Integer; { Total available space }
  TreeNode: TTreeNode;
  Rect: TRect;
  HasVertScrollBar, HasHorzScrollBar: Boolean;
  procedure DistributeExcess;
  var
    Excess, MinSize, i, nSmall: Integer;
    Sizes, MinSizes: array [0..2] of Integer;
  begin
    Excess := 0;
    MinSize := Available div 3;
    Sizes[0] := TreeViewSize;
    Sizes[1] := ParGridSize;
    Sizes[2] := OptGridSize;
    { First guess - divide into 3 equal parts, or smaller
      if fits }
    nSmall := 0; { Number needing less than 1/3 of space }
    for i := 0 to 2 do begin
      MinSizes[i] := Min(MinSize, Sizes[i]);
      Sizes[i] := MinSizes[i];
      if Sizes[i] < MinSize then begin
        Inc(Excess, MinSize - Sizes[i]);
        Inc(nSmall);
      end;
    end;
    { Second pass - share out excess }
    if nSmall > 0 then
      for i := 0 to 2 do begin
        if Sizes[i] = MinSize then
          Inc(Sizes[i], Excess div (3-nSmall));
      end;
    TreeViewSize := Sizes[0];
    ParGridSize := Sizes[1];
    OptGridSize := Sizes[2];
  end;
  function HeightNeeded(Grid: TCustomGrid):Integer;
  var
    i, W: Integer;
  begin
    with TOpenGrid(Grid) do begin
      Result := (DefaultRowHeight+GridLineWidth)*RowCount+GridLineWidth;
      if BorderStyle = bsSingle then
        Inc(Result,2);
      { Compute total width here, to avoid problems with appearing/disapearing scroll bars }
      W := GridLineWidth;
      for i := 0 to ColCount-1 do
        Inc(W, ColWidths[i]+GridLineWidth);
      { Assume Vertical scroll bar needed unless needs < 1/3 available space }
      if Result > Available div 3 then
        Inc(W,GetSystemMetrics(SM_CXVSCROLL));
      if W >= Width then
        Inc(Result, GetSystemMetrics(SM_CYHSCROLL)); { Horizontal Scroll Bar needed }
    end;
  end;
begin
  SplitR.MakeBothVisible;
  SplitL.MakeBothVisible;
  { Establish the preferred width of all the separate items }
  if SplitL.Align in [alLeft, alRight] then begin
    { Horozontal layout }
    Available := SelectPanel.Width - (SplitL.Width + SplitR.Width);
    TreeViewSize := 0;
    TreeNode := TreeView.Items.GetFirstNode;
    HasVertScrollBar := Assigned(TreeNode) and (TreeNode.DisplayRect(True).Top < 0);
    Rect.Bottom := 0;
    while Assigned(TreeNode) do begin
      Rect := TreeNode.DisplayRect(True);
      TreeViewSize := Max(TreeViewSize, Rect.Right);
      TreeNode := TreeNode.GetNext;
    end;
    HasVertScrollBar := HasVertScrollBar or (Rect.Bottom > TreeView.Height);
    if HasVertScrollBar then
      Inc(TreeViewSize, GetSystemMetrics(SM_CXVSCROLL));
    Inc(TreeViewSize, TreeView.BorderWidth+4);
    if Pargrid.ColCount > 2 then
      ParGridSize := ParGrid.NaturalWidth
    else
      ParGridSize := 0;
    OptGridSize := NaturalWidth(OptGrid);
    DistributeExcess;
    TreeView.Width := TreeViewSize;
    ValuePanel.Width := SelectPanel.Width - TreeViewSize - SplitL.Width;
    ParGrid.Width := ParGridSize;
    OptGrid.Width := OptGridSize;
  end else begin
    { Vertical layout }
    Available := SelectPanel.Height - (SplitL.Height + SplitR.Height + CommentPanel.Height);
    TreeViewSize := 0;
    TreeNode := TreeView.Items.GetFirstNode;
    HasHorzScrollBar := False;
    Rect.Bottom := 0;
    while Assigned(TreeNode) do begin
      if TreeNode.IsVisible then begin
        Rect := TreeNode.DisplayRect(True);
        HasHorzScrollBar := HasHorzScrollBar or (Rect.Left < 0) or (Rect.Right >= TreeView.Width);
        TreeViewSize := Min(TreeViewSize, Rect.Top);
      end;
      TreeNode := TreeNode.GetNext;
    end;
    TreeViewSize := Rect.Bottom - TreeViewSize;
    if HasHorzScrollBar then
      Inc(TreeViewSize, GetSystemMetrics(SM_CYHSCROLL));
    Inc(TreeViewSize, TreeView.BorderWidth+4);
    if Pargrid.ColCount > 2 then
      ParGridSize := HeightNeeded(ParGrid)
    else
      ParGridSize := 0;
    OptGridSize := HeightNeeded(OptGrid);
    DistributeExcess;
    TreeView.Height := TreeViewSize;
    ValuePanel.Height := SelectPanel.Height - TreeViewSize - SplitL.Height;
    ParGrid.Height := ParGridSize;
    OptGrid.Height := OptGridSize;
  end;
  if Assigned(CurrentMNode) then begin
    TreeNode := FindObject(TreeView,CurrentMNode);
    if Assigned(TreeNode) then
      TreeNode.MakeVisible;
  end;
end;

procedure TConstantsForm.OptGridDblClick(Sender: TObject);
begin
  {$IFDEF LCL}
  if LastCell.X = 1 then
    TurnOnEditing := True; { Can't turn on EditorMode here, as it gets turned off again by pending messages }
  {$ENDIF}
end;

procedure TConstantsForm.OptGridMouseDown(Sender: TOBject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  OptGrid.MouseToCell(X, Y, LastCell.X, LastCell.Y);
end;

procedure TConstantsForm.ConvertItemClick(Sender: TObject);
var
  i: Integer;
  MNode: TMNode;
begin
  if MessageDlg('Are you sure you want to convert the parameters?', mtConfirmation, mbYesNo, 0) <> mrYes then
    Exit;
  BeginUpdate;
  for i := 0 to nSelectedNodes - 1 do begin
    MNode := SelectedNode(i);
    if MNode is TState then
      TState(MNode).ConvertToPerturbations;
  end;
  EndUpdate;
end;

function TConstantsForm.PasteItemsIntoTree: Boolean;
var
  MNode: TMNode;
begin
  BeginUpdate;
  MNode := PasteXMLNodeOnto(CurrentMNode);
  Result := Assigned(MNode);
  if Result then
    CurrentMNode := Mnode;
  EndUpdate;
end;

procedure TConstantsForm.CopyParItemClick(Sender: TObject);
begin
  ParGrid.CopyToClipboard;
end;

procedure TConstantsForm.CutParItemClick(Sender: TObject);
begin
  ParGrid.CopyToClipboard;
  ParGrid.ClearSelection;
end;

procedure TConstantsForm.PasteParItemClick(Sender: TObject);
begin
  ParGrid.PasteFromClipboard;
end;

procedure TConstantsForm.EditParItemClick(Sender: TObject);
begin
  ParGrid.EditorMode := True;
end;

procedure TConstantsForm.EmptyParGrid;
begin
  with ParGrid do begin
    FixedRows := 0;
    RowCount := 1;
    ColCount := 2;
    Lbl[0] := ' ';
    Valid[0,1] := False;
  end;
end;

procedure TConstantsForm.ParPopupMenuPopup(Sender: TObject);
begin
  PasteParItem.Enabled := ClipboardHasText;
  EditParItem.Enabled := ParGrid.Col <> 2;
  ConverttoPerturbationItem.Visible := CurrentMNode is TState;
  MatrixElementsItem.Visible := CurrentMNode is TState;
  AddAllLevelsItem.Visible := Assigned(CurrentMNode.AncestorWithClass(TManifold));
  RemoveAllLevelsItem.Visible := (CurrentMNode is TManifold) or (CurrentMNode is TVariables);
  RemoveItem.Visible := RemoveAllLevelsItem.Visible;
  AddParameterItem.Visible := CurrentMNode is TVariables;
  if WheelAdjustActive then
    TurnonMouseAdjustItem.Caption := '&Turn off Mouse Adjust'
  else
    TurnonMouseAdjustItem.Caption := '&Turn on Mouse Adjust';
  AbortMouseAdjustItem.Visible := WheelAdjustActive;
end;

procedure TConstantsForm.ClearParItemClick(Sender: TObject);
begin
  BeginUpdate;
  try
    ParGrid.ClearSelection;
  finally
    EndUpdate;
  end;
end;

procedure TConstantsForm.OptPopupMenuPopup(Sender: TObject);
begin
  OptPasteItem.Enabled := ClipboardHasText;
  // EditParItem.Enabled := ParGrid.Col <> 2;
end;

procedure TConstantsForm.OptPasteItemClick(Sender: TObject);
begin
  OptGrid.PasteFromClipboard;
end;

procedure TConstantsForm.OptClearItemClick(Sender: TObject);
var
  r: Longint;
begin
  with OptGrid do
    if EditorMode then
      OptGrid.ClearSelection
    else
      for r := Selection.Top to Selection.Bottom do
        CurrentMNode.SetSettingFromStr(r+1,CurrentMNode.DefaultSettings[r+1]);
end;

procedure TConstantsForm.OptCopyItemClick(Sender: TObject);
begin
  OptGrid.CopyToClipboard;
end;

procedure TConstantsForm.OptCopyWithLabelsItemClick(Sender: TObject);
begin
  OptGrid.CopyToClipboard(True);
end;

procedure TConstantsForm.OptCutItemClick(Sender: TObject);
begin
  OptGrid.CopyToClipboard;
  OptClearItemClick(Sender);
end;

procedure TConstantsForm.OptEditItemClick(Sender: TObject);
begin
  OptGrid.EditorMode := True;
end;

end.
