program Pgopher;

{%ToDo 'Pgopher.todo'}

uses
  Forms,
  SysUtils,
  StackDump,
  LogUnit in 'LogUnit.pas' {LogForm},
  SpectrumPlot in 'SpectrumPlot.pas',
  ConstFrm in 'ConstFrm.pas' {ConstantsForm},
  LineFrm in 'LineFrm.pas' {LineForm},
  Obs in 'Obs.pas',
  Fitter in 'Fitter.pas',
  Mixture in 'Mixture.pas',
  OvrlyFrm in 'OvrlyFrm.pas' {OverlayForm},
  Life in 'Life.pas',
  MNode in 'MNode.pas',
  renform in 'renform.pas' {RenameForm},
  StateInfo in 'StateInfo.pas' {StatesForm},
  ChildForm in 'ChildForm.pas',
  TranInfo in 'TranInfo.pas' {TransitionForm},
  SymT in 'SymT.pas',
  HundA in 'HundA.pas',
  OAsymT in 'OAsymT.pas',
  CommandLine in 'CommandLine.pas',
  ImportACDD in 'ImportACDD.pas',
  PgopherImport in 'PgopherImport.pas',
  ExpPlot in 'ExpPlot.pas',
  MNodeColour in 'MNodeColour.pas',
  JDXLoader in '..\lutils\JDXLoader.pas',
  Units in '..\lutils\Units.pas',
  CheckOverlay in 'CheckOverlay.pas',
  DatLoader in '..\lutils\DatLoader.pas',
  QuantumMath in 'QuantumMath.pas',
  ExpBitmap in 'ExpBitmap.pas',
  Overlay in 'Overlay.pas',
  JPLCat in 'JPLCat.pas',
  ImportCALPGM in 'ImportCALPGM.pas',
  Progress in 'Progress.pas' {ProgressForm},
  GraphRange in 'GraphRange.pas',
  Plate in 'Plate.pas',
  DRintensity in 'DRintensity.pas',
  LineExportOpt in 'LineExportOpt.pas' {LineExportOptions},
  ReadBinary in 'ReadBinary.pas' {BinaryImportDlg},
  Hitran in 'Hitran.pas',
  PlotFrm in 'PlotFrm.pas' {PlotForm},
  Main in 'Main.pas' {MainForm},
  D3hImport in 'D3hImport.pas',
  Global in 'Global.pas',
  PlotOC in 'PlotOC.pas',
  FormUtils in 'FormUtils.pas',
  LineStrm in '..\utils\LineStrm.pas',
  MNodeClip in 'MNodeClip.pas',
  MatrixElements in 'MatrixElements.pas',
  CheckPgopher in 'CheckPgopher.pas',
  CalFrm in 'CalFrm.pas' {CalForm},
  PlotDataSource in 'PlotDataSource.pas',
  ExpPlotLoader in '..\lutils\ExpPlotLoader.pas',
  ApplyFrm in 'ApplyFrm.pas' {ApplyForm},
  DataSource in '..\lutils\DataSource.pas',
  I2 in 'I2.pas',
  CalSource in 'CalSource.pas',
  Atomic in 'Atomic.pas',
  DataFitter in '..\lutils\DataFitter.pas',
  SmoothDlg in 'SmoothDlg.pas' {SmoothForm},
  PGWork in 'PGWork.pas',
  LineOpt in 'LineOpt.pas' {LineFrmOptDlg},
  Interlock in 'Interlock.pas',
  SampleMols in 'SampleMols.pas',
  IPlotLoader in '..\lforms\IPlotLoader.pas',
  SPLoader in '..\lutils\SPLoader.pas',
  ObsSelect in 'ObsSelect.pas',
  ResidFrm in 'ResidFrm.pas' {ResidualForm},
  Settings in 'Settings.pas',
  SettingsForm in 'SettingsForm.pas',
  LevelFrm in 'LevelFrm.pas',
  SPCLoader in '..\lutils\SPCLoader.pas',
  DrvLoader in '..\lutils\DrvLoader.pas',
  CheckSpecView in 'CheckSpecView.pas',
  ImportSpecView in 'ImportSpecView.pas',
  ImportJB95 in 'ImportJB95.pas',
  CheckJB95 in 'CheckJB95.pas',
  SplineExpr in '..\lutils\SplineExpr.pas',
  Constrain in 'Constrain.pas',
  PSLoader in '..\lutils\PSLoader.pas',
  PartFunc in 'PartFunc.pas',
  ExternalList in 'ExternalList.pas',
  PickDest in '..\lforms\PickDest.pas' {PickDestForm},
  SplineOpt in '..\lforms\SplineOpt.pas' {SplineDlg},
  Gendlg in '..\lforms\Gendlg.pas' {NLFitDlg},
  ImportSTROTAB in 'ImportSTROTAB.pas',
  SIFLoader in '..\lutils\SIFLoader.pas',
  Vib in 'Vib.pas',
  NuclearInfo in 'NuclearInfo.pas',
  LmatrixFrm in 'LmatrixFrm.pas' {LMatrixForm},
  MatrixOps in '..\utils\MatrixOps.pas',
  DushinskyFrm in 'DushinskyFrm.pas' {DushinskyForm},
  Abelian in 'Abelian.pas',
  Vib2D in 'Vib2D.pas',
  DrLoader in '..\lutils\DrLoader.pas',
  DataTypes in '..\lutils\DataTypes.pas',
  TabbedLine in '..\lutils\TabbedLine.pas',
  Peaks in '..\lutils\Peaks.pas',
  Decomp in 'Decomp.pas',
  ImportLmatrix in 'ImportLmatrix.pas',
  LevelPlotter in 'LevelPlotter.pas',
  SymUtils in 'SymUtils.pas',
  OscFields in 'OscFields.pas',
  StaticField in 'StaticField.pas',
  Plotter in 'Plotter.pas',
  CompressDlg in 'CompressDlg.pas' {CompressForm},
  OverlaySumFitter in 'OverlaySumFitter.pas',
  SimpleQnos in 'SimpleQnos.pas';

{$R *.res}

begin
  {Compilation note: Define FASTMM4 with the compiler to use the FastMM4 unit in the
   Utils directory; recommended for Delphi2005 (and possibly below) but not for Delphi2006
   as the internal one is essentially the same as FastMM4 }
  { Under D2007 define FASTMM4 and DebugMM to enable checking }
  {$IFDEF FASTMM4} ReportMemoryLeaks := True; {$ENDIF}
  // ReportMemoryLeaksOnShutdown := True;
  StackWatch(True);
  DecimalSeparator := '.'; { See comment in HandleCommandLine; required here for FixedSpin to load from dfm files }
  Application.Initialize;
  Application.Title := 'Pgopher';
  Application.HelpFile := 'pgopher.chm';
  Application.CreateForm(TMainForm, MainForm);
  Application.CreateForm(TConstantsForm, ConstantsForm);
  Application.CreateForm(TOverlayForm, OverlayForm);
  Application.CreateForm(TRenameForm, RenameForm);
  Application.CreateForm(TTransitionForm, TransitionForm);
  Application.CreateForm(TLogForm, LogForm);
  Application.CreateForm(TProgressForm, ProgressForm);
  Application.CreateForm(TLineExportOptions, LineExportOptions);
  Application.CreateForm(TBinaryImportDlg, BinaryImportDlg);
  Application.CreateForm(TCalForm, CalForm);
  Application.CreateForm(TApplyForm, ApplyForm);
  Application.CreateForm(TSmoothForm, SmoothForm);
  Application.CreateForm(TLineFrmOptDlg, LineFrmOptDlg);
  Application.CreateForm(TResidualForm, ResidualForm);
  Application.CreateForm(TLineForm, LineForm);
  Application.CreateForm(TPickDestForm, PickDestForm);
  Application.CreateForm(TStatesForm, StatesForm);
  LevelForm := TLevelPlotter.Create(Application); { Confuses Delphi to use automatic mechanism as above }
  HandleCommandLine;
  Application.Run;
end.
