unit Blas;
{$I DFS.inc}
interface

uses MathSup;

{$IFDEF FPC}
{$IFNDEF EXTLAPACK}
{$LINKLIB pblas,STATIC}
{$ENDIF}
{$ELSE}
{$LINK blas.pobj}
{$ENDIF}

function dasum_(var n: Integer; var dx: Double; var incx: Integer): Double; cdecl; external;
function daxpy_(var n: Integer; var da: Double; var dx: Double; var incx: Integer; var dy: Double; var incy: Integer): Integer; cdecl; external;
function dcopy_(var n: Integer; var dx: Double; var incx: Integer; var dy: Double; var incy: Integer): Integer; cdecl; external;
function lsame_(var ca: Char; var cb: Char; ca_len: Integer; cb_len: Integer): LongBool; cdecl; external;
function dgemm_(var transa: Char; var transb: Char; var m: Integer; var n: Integer; var k: Integer; var alpha: Double; var a: Double; var lda: Integer; var b: Double; var ldb: Integer; var beta: Double; var c__: Double; var ldc: Integer; transa_len: Integer; transb_len: Integer): Integer; cdecl; external;
function dgemv_(var trans: Char; var m: Integer; var n: Integer; var alpha: Double; var a: Double; var lda: Integer; var x: Double; var incx: Integer; var beta: Double; var y: Double; var incy: Integer; trans_len: Integer): Integer; cdecl; external;
function dger_(var m: Integer; var n: Integer; var alpha: Double; var x: Double; var incx: Integer; var y: Double; var incy: Integer; var a: Double; var lda: Integer): Integer; cdecl; external;
function dnrm2_(var n: Integer; var x: Double; var incx: Integer): Double; cdecl; external;
function dscal_(var n: Integer; var da: Double; var dx: Double; var incx: Integer): Integer; cdecl; external;
function dswap_(var n: Integer; var dx: Double; var incx: Integer; var dy: Double; var incy: Integer): Integer; cdecl; external;
function dsymv_(var uplo: Char; var n: Integer; var alpha: Double; var a: Double; var lda: Integer; var x: Double; var incx: Integer; var beta: Double; var y: Double; var incy: Integer; uplo_len: Integer): Integer; cdecl; external;
function dsyr2_(var uplo: Char; var n: Integer; var alpha: Double; var x: Double; var incx: Integer; var y: Double; var incy: Integer; var a: Double; var lda: Integer; uplo_len: Integer): Integer; cdecl; external;
function dsyr2k_(var uplo: Char; var trans: Char; var n: Integer; var k: Integer; var alpha: Double; var a: Double; var lda: Integer; var b: Double; var ldb: Integer; var beta: Double; var c__: Double; var ldc: Integer; uplo_len: Integer; trans_len: Integer): Integer; cdecl; external;
function dtrmm_(var side: Char; var uplo: Char; var transa: Char; var diag: Char; var m: Integer; var n: Integer; var alpha: Double; var a: Double; var lda: Integer; var b: Double; var ldb: Integer; side_len: Integer; uplo_len: Integer; transa_len: Integer; diag_len: Integer): Integer; cdecl; external;
function dtrsm_(var side: Char; var uplo: Char; var transa: Char; var diag: Char; var m: Integer; var n: Integer; var alpha: Double; var a: Double; var lda: Integer; var b: Double; var ldb: Integer; side_len: Integer; uplo_len: Integer; transa_len: Integer; diag_len: Integer): Integer; cdecl; external;
function dtrmv_(var uplo: Char; var trans: Char; var diag: Char; var n: Integer; var a: Double; var lda: Integer; var x: Double; var incx: Integer; uplo_len: Integer; trans_len: Integer; diag_len: Integer): Integer; cdecl; external;
function idamax_(var n: Integer; var dx: Double; var incx: Integer): Integer; cdecl; external;
function ddot_(var n: Integer; var dx: Double; var incx: Integer; var dy: Double; var incy: Integer): Double; cdecl; external;
function drot_(var n: Integer; var dx: Double; var incx: Integer; var dy: Double; var incy: Integer; var c: Double; var s: Double): Double; cdecl; external;

function ztrmv_(var uplo: Char; var trans: Char; var diag: Char; var n: Integer; var a: Complex; var lda: Integer; var x: Complex; var incx: Integer; uplo_len: Integer; trans_len: Integer; diag_len: Integer): Integer; cdecl; external;
function zaxpy_(var n: Integer; var za: Complex; var zx: Complex; var incx: Integer; var zy: Complex; var incy: Integer): Integer; cdecl; external;
function zcopy_(var n: Integer; var zx: Complex; var incx: Integer; var zy: Complex; var incy: Integer): Integer; cdecl; external;
function zdotc_(var ret_val: Complex; var n: Integer; var zx: Complex; var incx: Integer; var zy: Complex; var incy: Integer): Integer; cdecl; external;
function zdscal_(var n: Integer; var da: Double; var zx: Complex; var incx: Integer): Integer; cdecl; external;
function zgemm_(var transa: Char; var transb: Char; var m: Integer; var n: Integer; var k: Integer; var alpha: Complex; var a: Complex; var lda: Integer; var b: Complex; var ldb: Integer; var beta: Complex; var c__: Complex; var ldc: Integer; transa_len: Integer; transb_len: Integer): Integer; cdecl; external;
function zgemv_(var trans: Char; var m: Integer; var n: Integer; var alpha: Complex; var a: Complex; var lda: Integer; var x: Complex; var incx: Integer; var beta: Complex; var y: Complex; var incy: Integer; trans_len: Integer): Integer; cdecl; external;
function zgerc_(var m: Integer; var n: Integer; var alpha: Complex; var x: Complex; var incx: Integer; var y: Complex; var incy: Integer; var a: Complex; var lda: Integer): Integer; cdecl; external;
function zhemv_(var uplo: Char; var n: Integer; var alpha: Complex; var a: Complex; var lda: Integer; var x: Complex; var incx: Integer; var beta: Complex; var y: Complex; var incy: Integer; uplo_len: Integer): Integer; cdecl; external;
function zher2_(var uplo: Char; var n: Integer; var alpha: Complex; var x: Complex; var incx: Integer; var y: Complex; var incy: Integer; var a: Complex; var lda: Integer; uplo_len: Integer): Integer; cdecl; external;
function zher2k_(var uplo: Char; var trans: Char; var n: Integer; var k: Integer; var alpha: Complex; var a: Complex; var lda: Integer; var b: Complex; var ldb: Integer; var beta: Double; var c__: Complex; var ldc: Integer; uplo_len: Integer; trans_len: Integer): Integer; cdecl; external;
function zscal_(var n: Integer; var za: Complex; var zx: Complex; var incx: Integer): Integer; cdecl; external;
function zswap_(var n: Integer; var zx: Complex; var incx: Integer; var zy: Complex; var incy: Integer): Integer; cdecl; external;
function ztrmm_(var side: Char; var uplo: Char; var transa: Char; var diag: Char; var m: Integer; var n: Integer; var alpha: Complex; var a: Complex; var lda: Integer; var b: Complex; var ldb: Integer; side_len: Integer; uplo_len: Integer; transa_len: Integer; diag_len: Integer): Integer; cdecl; external;
function dznrm2_(var n: Integer; var x: Complex; var incx: Integer): Double; cdecl; external;

implementation

uses f2c;

end.

