unit ShellSort;
{$I DFS.inc}{ Copyright (C) 2005 C M Western; see UCompat.pas for license}
interface

type
  TShellSorter = class
    function InOrder(I,J:Integer):Boolean; virtual; abstract;
    procedure Swap(I,J: Integer); virtual; abstract;
    procedure Sort(N: Integer); { Indexed 0..N-1 }
  end;

procedure SwapValues(var A, B; Size: Integer);

procedure Sort(var A: array of Integer; nItems: Integer = -1);

implementation

procedure Sort(var A: array of Integer; nItems: Integer);
var
  I, J, Offset, t: Integer;
  IsInOrder: Boolean;
begin
  { Must be an easier way of doing this than copying text.... }
  if nItems < 0 then
    nItems := Length(A);
  Offset := nItems;
  while Offset > 1 do begin
    Offset := Offset shr 1;
    repeat
      IsInOrder := True;
      for J := 0 to nItems - Offset - 1 do begin
        I := J + Offset;
        if A[J] > A[I] then begin
          IsInOrder := False;
          t := A[I];
          A[I] := A[J];
          A[J] := t;
        end;
      end;
    until IsInOrder;
  end;
end;

{ TShellSorter }

procedure TShellSorter.Sort(N: Integer);
var
  I, J, Offset: Integer;
  IsInOrder: Boolean;
begin
  { ShellSort }
  Offset := N;
  while Offset > 1 do begin
    Offset := Offset shr 1;
    repeat
      IsInOrder := True;
      for J := 0 to N - Offset - 1 do begin
        I := J + Offset;
        if not InOrder(J,I) then begin
          IsInOrder := False;
          Swap(I,J);
        end;
      end;
    until IsInOrder;
  end;
end;

procedure SwapValues(var A, B; Size: Integer);
var
  PA, PB: PChar;
  T: Integer;
  C: Char;
begin
  PA := @A;
  PB := @B;
  while Size >= SizeOf(Integer) do begin
    T := PInteger(PA)^;
    PInteger(PA)^ := PInteger(PB)^;
    PInteger(PB)^ := T;
    Dec(Size, SizeOf(Integer));
    Inc(PA, SizeOf(Integer));
    Inc(PB, SizeOf(Integer));
  end;
  while Size > 0 do begin
    C := PA^;
    PA^ := PB^;
    PB^ := C;
    Dec(Size, 1);
    Inc(PA, 1);
    Inc(PB, 1);
  end;
end;

end.
