unit HugeClip;
{$I DFS.inc}{ Copyright (C) 2005 C M Western; see PcontrolsReg.pas for license}

interface

uses
  Classes, SysUtils; 

implementation

uses {$IFDEF MSWINDOWS} Windows, {$ENDIF}
     {$IFDEF LCL_} LCLType, {$ENDIF}
     {$IFNDEF CLX_} ClipBrd, {$ELSE} QClipbrd, {$ENDIF}
     Huge;

type
 TOpenGHandle = class (TGHandle)
 end;

procedure DoCopyHandleToClipboard(GHandle: TGHandle; Format:Cardinal);
begin
  {$IFDEF MSWINDOWS}
    {$IFNDEF LCL_}
      if GHandle.Base <> nil then GlobalUnlock(TOpenGHandle(GHandle).FHandle);
      TOpenGHandle(GHandle).FBase := nil;
      Clipboard.SetAsHandle(Format, TOpenGHandle(GHandle).FHandle);
      TOpenGHandle(GHandle).FHandle := 0;
      TOpenGHandle(GHandle).FSize := 0;
    {$ELSE}
      Clipboard.AddFormat(Format, TOpenGHandle(GHandle).FBase^, TOpenGHandle(GHandle).FSize);
      GHandle.Clear; { Not essential, but windows Delphi version does this }
    {$ENDIF}
  {$ENDIF}
  {$IFDEF UNIX}
    if Format = CF_TEXT then begin
      { Check null terminator present }
      if PChar(GHandle.Base)[GHandle.Size-1] <> #0 then begin
        GHandle.Size := GHandle.Size + 1;
        PChar(GHandle.Base)[GHandle.Size-1] := #0;
      end;
      Clipboard.AsText := PChar(GHandle.Base)
    end else
      Clipboard.AddFormat(Format, TOpenGHandle(GHandle).FBase^, TOpenGHandle(GHandle).FSize);
    // else { TODO: Handle more formats }
      // raise Exception.CreateFmt('TGHandle.CopyToClipboard(%d)', [Format]);
    GHandle.Clear; { Not essential, but windows version does this }
  {$ENDIF}
end;

procedure DoSetHandleFromClipboard(GHandle: TGHandle; Format:Cardinal);
{$IFNDEF VCL_}
var
  Stream: THugeMemoryStream;
{$ENDIF}
begin
  if not Assigned(GHandle) then begin
    Clipboard.CLose;
    Exit;
  end;
  {$IFDEF VCL_}
  GHandle.Clear;
  ClipBoard.Open;
  with TOpenGHandle(GHandle) do begin
    FHandle := Clipboard.GetAsHandle(Format);
    if FHandle <> 0 then begin
      FBase := GlobalLock(FHandle);
      FSize := GlobalSize(FHandle);
      FromClipboard := True;
    end else
      Clipboard.Close;
  end;
  {$ELSE}
  GHandle.Clear;
  Stream := THugeMemoryStream.Create(GHandle);
  try
    ClipBoard.GetFormat(Format, Stream);
    if (Format = CF_TEXT) and ((Stream.Position = 0) or (PChar(GHandle.Item[Stream.Position-1]) <> #0)) then
      Stream.WriteByte(0); { Add null terminator if one not already present }
    GHandle.Size := Longint(Stream.Position);
  finally
    Stream.Disconnect;
    Stream.Free;
  end;
  {Old:
  s := Clipboard.AsText;
  Size := Length(s)+1;
  Move(s[1], FBase^, Size);}
  {$ENDIF}
end;

initialization
  CopyHandleToClipboard := {$IFDEF FPC}@{$ENDIF} DoCopyHandleToClipboard;
  SetHandleFromClipboard := {$IFDEF FPC}@{$ENDIF} DoSetHandleFromClipboard;
end.

